#include <cstdio>
#include <cstdlib>
#include <cstdarg>
#include <cctype>

#define YL "kood"
#define IN (argc > 1 ? argv[1] : YL "sis.txt")
#define OUT (argc > 3 ? argv[3] : YL "val.txt")
#define HINT (argc > 2 ? argv[2] : YL "xxx.txt")
#define MAXLINE 1000
#define MAXN 200
#define MAXM 200
#define MAXK 100

void RET(double r, const char *s, ...) {
	printf("%lf\n", r);
	va_list ap;
	va_start(ap, s);
	vfprintf(stderr, s, ap);
	va_end(ap);
	fprintf(stderr, "\n");
	exit(0);
}

int isblank(const char *s) {
	while (*s != 0) {
		if (isspace(*s)) {
			++s;
		} else {
			return 0;
		}
	}
	return 1;
}

int n, m, k;
char a[MAXN][MAXM];
char s[MAXLINE];
int ch, co;
int u, r, v;

int main(int argc, const char *argv[]) {
	FILE *in = fopen(IN, "rt");
	if (!in) {
		RET(0, "Viga sisendfaili avamisel");
	}
	if (fgets(s, sizeof(s), in) == NULL) {
		RET(0, "Vigane sisend");
	}
	if (sscanf(s, "%d%d%d%n", &n, &m, &k, &u) != 3 || !isblank(s + u)) {
		RET(0, "Vigane sisend");
	}
	if (n < 2 || n > MAXN || m < 2 || m > MAXM || k < 1 || k > MAXK) {
		RET(0, "Vigane sisend");
	}
	for (int i = 0; i < n; ++i) {
		if (fgets(s, sizeof(s), in) == NULL) {
			RET(0, "Vigane sisend");
		}
		for (int j = 0; j < m; ++j) {
			if (s[j] != '#' && (s[j] < '0' || s[j] > '9')) {
				RET(0, "Vigane sisend");
			}
			a[i][j] = s[j];
		}
		if (!isblank(s + m)) {
			RET(0, "Vigane sisend");
		}
	}
	if (fscanf(in, "%10s", s) > 0) {
		RET(0, "Vigane sisend");
	}

	FILE *hint = fopen(HINT, "rt");
	if (!hint) {
		RET(0, "Viga vihjefaili avamisel");
	}
	if (fgets(s, sizeof(s), hint) == NULL) {
		RET(0, "Vigane vihje");
	}
	u = 0;
	while (s[u] == 'R' || s[u] == 'D') {
		++u;
	}
	if (u < 1 || u > k || !isblank(s + u)) {
		RET(0, "Vigane vihje");
	}
	ch = a[0][0] - '0';
	r = v = 0;
	for (int i = 0; ; ++i) {
		if (i >= u) {
			i = 0;
		}
		if (s[i] == 'R') {
			++v;
		}
		if (s[i] == 'D') {
			++r;
		}
		if (r >= n || v >= m) {
			break;
		}
		if (a[r][v] == '#') {
			RET(0, "Vigane vihje");
		}
		ch += a[r][v] - '0';
	}
	if (fscanf(hint, "%10s", s) > 0) {
		RET(0, "Vigane vihje");
	}

	FILE *out = fopen(OUT, "rt");
	if (!out) {
		RET(0, "Viga väljundfaili avamisel");
	}
	if (fgets(s, sizeof(s), out) == NULL) {
		RET(0, "Vigane väljund");
	}
	u = 0;
	while (s[u] == 'R' || s[u] == 'D') {
		++u;
	}
	if (u < 1 || u > k || !isblank(s + u)) {
		RET(0, "Vigane väljund");
	}
	co = a[0][0] - '0';
	r = v = 0;
	for (int i = 0; ; ++i) {
		if (i >= u) {
			i = 0;
		}
		if (s[i] == 'R') {
			++v;
		}
		if (s[i] == 'D') {
			++r;
		}
		if (r >= n || v >= m) {
			break;
		}
		if (a[r][v] == '#') {
			RET(0, "Vigane väljund");
		}
		co += a[r][v] - '0';
	}
	if (fscanf(out, "%10s", s) > 0) {
		RET(0, "Vigane väljund");
	}

	RET(0.5 + 0.5 * double(co) / double(ch), "OK");
}
