#include <cstdio>
#include <iostream>
using namespace std;

template <typename T> T sqr(T x) { return x * x; }
template <typename T> T abs(T x) { return x < 0 ? -x : x; }
template <typename T> T gcd(T a, T b) { return b ? gcd(b, a % b) : a; }
#define FOREACH(a, b) for(typeof((b).begin()) a = (b).begin(); a != (b).end(); ++a)

typedef long long ll;

const ll INF = (ll)1e+18 + 7;

inline void relax(ll &a, const ll b)
{
    if (a > b) {
        a = b;
    }
}

int main(int argc, char **argv)
{
    freopen("poodsis.txt", "rt", stdin);
    freopen("poodval.txt", "wt", stdout);

    int n, m, k;
    cin >> n >> m >> k;
    int a[n];
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    ll f[n + 1][m + 1];
    ll ans = INF;
    for (int l = 0; l <= m; ++l) {
        for (int i = 0; i <= n; ++i) {
            for (int j = 0; j <= l; ++j) {
                f[i][j] = INF;
            }
        }
        f[0][0] = 0;

        for (int i = 0; i < n; ++i) {
            for (int j = 0; j <= l; ++j) {
                if (f[i][j] != INF) {
                    if (j < l) {
                        relax(f[i + 1][j + 1], f[i][j] + ((n - l + j + 1) % k == 0? 0 : a[i]));
                    }
                    relax(f[i + 1][j], f[i][j] + ((i - j + 1) % k == 0? 0 : a[i]));
                }
            }
        }
        relax(ans, f[n][l]);
    }

    cout << ans << endl;
    return 0;
}
