#include <iostream>
#include <fstream>
#include <string.h>

#define MAX_N 10
#define GOOD_SQUARE 10 

using namespace std;

/*
GOOD_SQUARE is subtracted from the neighbors touched in cases when we
don't care what the value is
*/

int m, n, xs, ys, xe, ye;
int c1; /* number of good paths */
int touched[MAX_N][MAX_N];
int total_touched;

int target;
int neighbors_touched[MAX_N][MAX_N];

void go(int x, int y)
{
	if (x == xe && y == ye) {
		if (total_touched == target)
			c1++;
		return;
	}

	if (touched[x][y])
		return;

	neighbors_touched[x + 1][y]++;
	neighbors_touched[x][y + 1]++;
	neighbors_touched[x - 1][y]++;
	neighbors_touched[x][y - 1]++;

	int dead_ends = 0;

	if (neighbors_touched[x + 1][y] > 2)
		dead_ends++;
	if (neighbors_touched[x][y + 1] > 2)
		dead_ends++;
	if (neighbors_touched[x - 1][y] > 2)
		dead_ends++;
	if (neighbors_touched[x][y - 1] > 2)
		dead_ends++;

	/* prune cases of more than one dead end */
	//	if (dead_ends <= 1) 
	{

		touched[x][y] = 1;
		neighbors_touched[x][y] -= GOOD_SQUARE;

		total_touched++;

		/* if there is one "dead end", make sure we go to it next */
		//if (dead_ends == 1) {
		//	if (neighbors_touched[x + 1][y] > 2)
		//		go(x + 1, y);
		//	if (neighbors_touched[x][y + 1] > 2)
		//		go(x, y + 1);
		//	if (neighbors_touched[x - 1][y] > 2)
		//		go(x - 1, y);
		//	if (neighbors_touched[x][y - 1] > 2)
		//		go(x, y - 1);
		//}
		//else if (dead_ends == 0) 
		{
			go(x + 1, y);
			go(x, y + 1);
			go(x - 1, y);
			go(x, y - 1);
		}

		total_touched--;

		neighbors_touched[x][y] += GOOD_SQUARE;
		touched[x][y] = 0;
	}

	neighbors_touched[x + 1][y]--;
	neighbors_touched[x][y + 1]--;
	neighbors_touched[x - 1][y]--;
	neighbors_touched[x][y - 1]--;
}


int main()
{
	memset(touched, 0, sizeof(touched));
	memset(neighbors_touched, 0, sizeof(neighbors_touched));
	total_touched = 0;
	c1 = 0;
	ifstream sis;
	string filename = "ruutsis.txt";
	sis.open(filename);

	sis >> m >> n >> xs >> ys >> xe >> ye;
	//cin >> m >> n >> xs >> ys >> xe >> ye;

	target = n*m - 1;

	for (int i = 1; i <= m; i++) {
		touched[i][n + 1] = 1;
		touched[i][0] = 1;

		neighbors_touched[i][1]++;
		neighbors_touched[i][n]++;

		neighbors_touched[i][0] = -GOOD_SQUARE;
		neighbors_touched[i][n + 1] = -GOOD_SQUARE;
	}

	for (int i = 1; i <= n; i++) {
		touched[m + 1][i] = 1;
		touched[0][i] = 1;

		neighbors_touched[1][i]++;
		neighbors_touched[m][i]++;

		neighbors_touched[0][i] = -GOOD_SQUARE;
		neighbors_touched[m + 1][i] = -GOOD_SQUARE;
	}

	neighbors_touched[xe][ye] = -GOOD_SQUARE;

	go(xs, ys);

	ofstream val;
	filename = "ruutval.txt";
	val.open(filename);
	val << c1;
	cout << c1;
	val.close();
}
